from src.dictionaries.morphosyntactic.pl_ner import PlNERMorphosyntacticDictionary
from src.annotations import NameAnnotation, CityAnnotation, SurnameAnnotation

def test_pl_ner_morphosyntactic_dictionary():
    dictionary = PlNERMorphosyntacticDictionary(list=[
        (NameAnnotation, "Andrzejowi", "Andrzej", "subst:sg:dat:m1"),
        (NameAnnotation, "Andrzej", "Andrzej", "subst:sg:m1:imperf"),
        (NameAnnotation, "Kasia", "Kasia", "subst:sg:f:imperf"),
        (CityAnnotation, "Wrocław", "Wrocław", "subst:sg:m2:imperf"),
        (CityAnnotation, "Warszawa", "Warszawa", "subst:sg:f:imperf"),
        (CityAnnotation, "Kraków", "Kraków", "subst:sg:m2:imperf")
    ])
    
    example_name_1 = NameAnnotation(morpho_tag="subst:sg:dat:m1")
    example_name_2 = NameAnnotation(morpho_tag="subst:sg:m1:imperf")
    example_other = SurnameAnnotation(morpho_tag="subst:sg:m1:imperf")
    
    assert dictionary.get_random_replacement(example_name_1) == "Andrzejowi"
    assert dictionary.get_random_replacement(example_name_2) in ["Andrzej", "Kasia"]
    
    # I no good replacement is present, it should choose a random one
    assert dictionary.get_random_replacement(example_other) in ["Andrzejowi" ,"Andrzej", "Kasia", "Wrocław", "Warszawa", "Kraków"]